<template>
  <div class="q-ma-md q-mb-lg">
    <div class="
        text-subtitle1 text-grey-7 text-uppercase text-weight-medium
        row
        justify-between
        items-center
        q-my-lg">
      <div class="col">
        {{ title }}
      </div>
      <div class="col-auto">
        <q-btn v-if="showCallAllButton && showcallall" color="positive" rounded @click="handleCallAll"
          :disable="disableCallAllButton">{{ $t("conference.callall") }}
        </q-btn>
      </div>
    </div>
    <q-list v-if="cleanedParticipants !== undefined" separator>
      <q-item v-for="(participant, phoneNumber) in cleanedParticipants" :key="phoneNumber" class="q-px-none">
        <q-item-section side v-if="participant.Status === 'Active'" class="q-pa-none q-pr-md"
          style="display: inline-block justify-center items-center">
          <div>
            <q-spinner v-if="dismissHandsWorking.includes(phoneNumber)" color="orange" size="1.5em"
              style="margin-right:10px" :thickness="4" />
            <q-icon v-else-if="participant.HandUp" size="md" color="orange" name="front_hand"
              @click="handleRequestHandDown(phoneNumber)" style="margin-right:10px">
              <q-tooltip>
                {{ $t("participant_list.hand_up") }}
              </q-tooltip>
            </q-icon>
            <q-toggle dense :disable="muteParticipantLoading[phoneNumber]"
              @input="handleMuteParticipant(participant, phoneNumber)" :value="!participantIsMuted(participant)"
              size="lg" color="green" checked-icon="mic" unchecked-icon="mic_off" />
          </div>
        </q-item-section>

        <q-item-section side class="q-pa-none q-pr-sm" v-if="participant.Status !== 'Active'">

          <q-icon v-if="!showCallButton(participant)" name="pending" class="q-mr-md" />

          <q-btn v-if="showCallButton(participant)" @click="handleRequestCallParticipant(phoneNumber)" color="positive"
            rounded flat dense :disable="participantBeingCalled(phoneNumber)">
            <div class="q-mr-sm">
              <q-spinner v-if="participantBeingCalled(phoneNumber)" />
              <q-icon v-else name="phone" />
            </div>
          </q-btn>

        </q-item-section>

        <q-item-section>

          <q-item-label :class="`text-${textColorForParticipant(participant)} row text-body1`">
            {{ participant.Name }}
            <div class="q-ml-sm text-grey text-bold" v-if="participant.Banned">
              ({{ $t("participant_list.banned") }})
            </div>
            <div class="q-ml-sm" v-if="participant.Status === 'Active'">
              <q-icon v-if="participant.Moderator" color="orange" name="star"
                style="margin-right:5px; font-size: 0.9em; padding-bottom:2px;">
              </q-icon>
              <q-icon v-if="participant.Speaking && !participant.Muted" name="volume_up" />
            </div>
          </q-item-label>

          <q-item-label caption style="text-transform: uppercase">
            {{ phoneNumber }} | {{ statusDescription(participant) }}
          </q-item-label>

        </q-item-section>

        <q-item-section side v-if="participant.Status === 'Active'">
            <div class="btn-wrapper stay-right">
              <q-btn
                color="white bg-red"
                @click="requestHangup(participant, phoneNumber)"
                icon="call_end"
                round />
            </div>
        </q-item-section>
        
        <q-item-section side>
          <q-btn icon="more_vert" flat round dense>
            <q-menu>
              <q-list>

                <q-item clickable v-close-popup @click="handleRequestRename(phoneNumber)">

                  <q-item-section>
                    {{ $t("conference.rename") }}
                  </q-item-section>

                </q-item>

                <q-item v-if="showBanOption(phoneNumber)" clickable v-close-popup
                  @click="handleRequestBan(phoneNumber)">
                  <q-item-section>
                    {{ $t("conference.ban") }}
                  </q-item-section>
                </q-item>
              </q-list>
            </q-menu>
          </q-btn>
        </q-item-section>
      </q-item>
    </q-list>
    <q-dialog v-model="showRenameDialog">
      <q-card>
        <q-form @submit="handleRenameParticipant">
          <q-card-section class="q-pb-none">
            <q-input :rules="[(val) => (val && val.length > 0) || $t('empty.name')]" v-model="newNameValue" autofocus />
          </q-card-section>
          <q-card-actions align="right">
            <q-btn :label="$t('save')" flat color="primary" type="submit" />
          </q-card-actions>
        </q-form>
      </q-card>
    </q-dialog>
    <span class="text-center q-my-md" style="width: 100%" v-if="participantCount == 0">{{
        $t("participant_list.no_participants")
    }}</span>
  </div>
</template>

<script>
import { functions } from "../firebase";

export default {
  props: {
    showcallall: {
      type: Boolean,
      default: true,
    },
    title: {
      required: true,
      type: String,
    },
    participants: {
      required: true
    },
    usersPhone: {
      required: true,
      type: String,
    },
    hasCapacity: {
      type: Boolean
    }
  },
  data()
  {
    return {
      contacts: { loading: true },
      renamingParticipantKey: undefined,
      dismissHandsWorking: [],
      newNameValue: "",
      // This is a map of participant phone numbers to booleans
      // if the boolean is true - the user has pressed call for this
      // participant and we are waiting for the participant to answer/hangup
      callbuttonPressedUsers: {},
      // This is a map of participant phone numbers to booleans
      // if the boolean is true - toggling that participant's mute status
      // is loading
      muteParticipantLoading: {},
    };
  },
  computed: {
    cleanedParticipants()
    {
      let toRet = {};
      if (this.participants)
      {
        for (const num in this.participants)
        {
          if (num != 1000)
          {
            toRet[num] = this.participants[num];
          }
        }
      }
      return toRet;
    },
    participantCount()
    {
      if (this.cleanedParticipants == undefined) return 0;
      return Object.keys(this.cleanedParticipants).length;
    },
    showRenameDialog: {
      get()
      {
        if (this.renamingParticipantKey !== undefined) return true;
        return false;
      },
      set()
      {
        this.renamingParticipantKey = undefined;
      },
    },
    showCallAllButton()
    {
      let show = false;
      for (const phoneNumber in this.cleanedParticipants)
      {
        if (this.showCallButton(this.cleanedParticipants[phoneNumber])) show = true;
      }
      return show;
    },
    disableCallAllButton()
    {
      let disable = true;
      for (const phoneNumber in this.cleanedParticipants)
      {
        if (!this.callbuttonPressedUsers[phoneNumber]) disable = false;
      }
      return disable;
    },
  },
  watch: {
    participants(newParticipants) 
    {
      const hideSpinnerStatuses = ['Active', 'Hangup', 'Timeout', 'ERROR'];

      for (const phoneNumber in newParticipants) 
      {
        if (!newParticipants || !newParticipants[phoneNumber])
        {
          continue;
        }

        hideSpinnerStatuses.forEach(status =>
        {
          if (newParticipants[phoneNumber].Status &&
            newParticipants[phoneNumber].Status.includes(status))
          {
            this.callbuttonPressedUsers = {
              ...this.callbuttonPressedUsers,
              [phoneNumber]: false,
            };
          }
        });
      }
    },
  },
  methods: {
    async requestHangup(participant, phoneNumber) {
      
      this.$q
        .dialog({
          title: this.$t("confirm"),
          message: this.$t("conference.hangup_participant_confirmation"),
          ok: { label: this.$t("confirm"), flat: true, color: "negative" },
          cancel: { label: this.$t("cancel"), flat: true, color: "grey-7" },
        })
        .onOk(async () =>
        {
          
          const fbHangup = functions.httpsCallable(
            "hangupParticipant"
          );
     
          await fbHangup({
            ConferenceId: this.$route.params.id,
            ParticipantNumber: phoneNumber,
            Uuid: participant.SessionData.CallUuid,
            ConfMemberId: participant.SessionData.ConfMemberId,
          });
  
        });
    },

    handleRequestCallParticipant(phoneNumber)
    {
      // If the participant is banned, confirm that the
      // user wants to unban them before calling
      if (this.cleanedParticipants[phoneNumber].Banned)
      {
        this.$q
          .dialog({
            title: this.$t("confirm"),
            message: this.$t("participant_list.confirm_call_banned"),
            ok: { label: this.$t("confirm"), flat: true, color: "negative" },
            cancel: { label: this.$t("cancel"), flat: true, color: "grey-7" },
          })
          .onOk(async () =>
          {
            this.startCallingParticipant(phoneNumber);
          });
      } else
      {
        this.startCallingParticipant(phoneNumber);
      }
    },
    showCallButton(participant) 
    {
      if(!this.hasCapacity) return false;
      const status = participant.Status;
      return status == "Invited" || status == "Hangup" || status == "Timeout" || status.includes('ERROR');
    },
    statusDescription(participant) 
    {
      if (participant.Status === "Active") 
      {
        return this.$t(`participant_list.muted_${this.participantIsMuted(participant)}`);
      }
      else if (participant.Status.includes('ERROR'))
      {
        const err = participant.Status.replace('ERROR', '').trim();
        return this.$t(`errors.${err}`);
      }
      else if (participant.Status.includes('WAITING_RETRY'))
      {
        const attempt = parseInt(participant.Status.replace('WAITING_RETRY', ''));
        return this.$t(`participant_list.retry_waiting`, [attempt]);
      }
      else if (participant.Status.includes('RETRYING'))
      {
        const attempt = parseInt(participant.Status.replace('RETRYING', ''));
        return this.$t(`participant_list.retrying`, [attempt]);
      }
      return this.$t(`participant_list.${participant.Status}`);
    },
    participantIsMuted(participant)
    {
      return participant.Muted === undefined ? false : participant.Muted;
    },
    async handleMuteParticipant(participant, phoneNumber)
    {
      const fbMuteUnMuteParticipant = functions.httpsCallable(
        "muteUnmuteParticipant"
      );
      this.muteParticipantLoading = {
        ...this.muteParticipantLoading,
        [phoneNumber]: true,
      };
      await fbMuteUnMuteParticipant({
        ConferenceId: this.$route.params.id,
        ParticipantNumber: phoneNumber,
        Uuid: participant.SessionData.CallUuid,
        ConfMemberId: participant.SessionData.ConfMemberId,
        Muted: !this.participantIsMuted(participant),
      });
      this.muteParticipantLoading = {
        ...this.muteParticipantLoading,
        [phoneNumber]: false,
      };
    },
    textColorForParticipant(participant)
    {
      if (participant.Status === "Active")
      {
        if (participant.Muted) return "red";
        if (participant.Speaking) return "green";
      }
      return "dark";
    },
    async handleRequestHandDown(phoneNumber)
    {
      this.dismissHandsWorking.push(phoneNumber)
      const dismissHandFb = functions.httpsCallable("dismissHandUp");
      await dismissHandFb({
        ConferenceId: this.$route.params.id,
        ParticipantNumber: phoneNumber,
      });
      let ind = this.dismissHandsWorking.indexOf(phoneNumber);
      if (ind !== -1) this.dismissHandsWorking.splice(ind, 1)
    },
    handleRequestRename(phoneNumber)
    {
      this.renamingParticipantKey = phoneNumber;
      this.newNameValue = this.cleanedParticipants[phoneNumber].Name;
    },
    async handleRenameParticipant()
    {
      this.$q.loading.show();
      const renameParticipantFb = functions.httpsCallable("renameUser");
      await renameParticipantFb({
        Conference: this.$route.params.id,
        PhoneNumber: this.renamingParticipantKey,
        Name: this.newNameValue,
      });
      this.$q.loading.hide();
      this.renamingParticipantKey = undefined;
    },
    async handleRequestBan(phoneNumber)
    {
      this.$q.loading.show();
      const bootParticipantFb = functions.httpsCallable("banParticipant");
      await bootParticipantFb({
        ConferenceId: this.$route.params.id,
        ParticipantNumber: phoneNumber,
      });
      this.$q.loading.hide();
    },
    showBanOption(phoneNumber)
    {
      return (
        phoneNumber !== this.usersPhone &&
        !this.cleanedParticipants[phoneNumber].Banned
      );
    },
    participantBeingCalled(phoneNumber)
    {
      return (
        (phoneNumber == this.usersPhone && this.$route.query.callPhone &&
          this.cleanedParticipants[phoneNumber].Status === "Invited") ||
        this.callbuttonPressedUsers[phoneNumber]
      );
    },
    startCallingParticipant(phoneNumber)
    {
      this.callbuttonPressedUsers = {
        ...this.callbuttonPressedUsers,
        [phoneNumber]: true,
      };
      this.$forceUpdate();
      this.$emit("callParticipant", phoneNumber);
    },
    handleCallAll()
    {
      for (const phoneNumber in this.cleanedParticipants)
      {
        if (
          this.showCallButton(this.cleanedParticipants[phoneNumber]) &&
          !this.callbuttonPressedUsers[phoneNumber]
        )
          this.startCallingParticipant(phoneNumber);
      }
    },
  },
};
</script>

